// DumpStatic.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "RemMFC.h"
#include "DumpStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CFontSelect
CFontSelect::CFontSelect(CDC *pDC, CFont *pFont)
{
	m_pDC = pDC;
	m_pFont = pDC->SelectObject(pFont);
}
void CFontSelect::Release(void)
{
	if( m_pFont ){
		m_pDC->SelectObject(m_pFont);
		m_pFont = NULL;
	}
}
// CPenSelect
CPenSelect::CPenSelect(CDC *pDC, CPen *pPen)
{
	m_pDC = pDC;
	m_pPen = pDC->SelectObject(pPen);
}
void CPenSelect::Release(void)
{
	if( m_pPen ){
		m_pDC->SelectObject(m_pPen);
		m_pPen = NULL;
	}
}
// CBrushSelect
CBrushSelect::CBrushSelect(CDC *pDC, CBrush *pBrush)
{
	m_pDC = pDC;
	m_pBrush = pDC->SelectObject(pBrush);
}
void CBrushSelect::Release(void)
{
	if( m_pBrush ){
		m_pDC->SelectObject(m_pBrush);
		m_pBrush = NULL;
	}
}
/////////////////////////////////////////////////////////////////////////////
// CDumpStatic
CDumpStatic::CDumpStatic()
{
	m_bEdit = FALSE;
	m_pFont = NULL;
	m_pScrollBar = NULL;
	m_bIconic = FALSE;

	m_nTimerID = 0;
	m_Cursor = 0;
	m_CursorF = 0;

	m_Init = 0;
	m_Scroll = 0;
	m_Top = 0;
	m_Line = 0;
	m_Col = 0;
	m_Count = 0;
	m_WriteLine = 0;
	m_ReadLine = 0;
	m_ReadCol = 0;

	m_clBack = RGB(255,255,255);
	m_ColMax = 0;
	m_LineMax = 0;

	memset(m_pList, 0, sizeof(m_pList));
	memset(&m_rcClient, 0, sizeof(m_rcClient));

	LOGFONT	logfont;
	memset(&logfont, 0, sizeof(logfont));
	logfont.lfCharSet = ANSI_CHARSET;
	logfont.lfHeight = -15;
	logfont.lfWeight = FW_REGULAR;
	strcpy(logfont.lfFaceName, "Courier New");
	m_pFont = new CFont;
	m_pFont->CreateFontIndirect(&logfont);
	m_CXVSCROLL = ::GetSystemMetrics(SM_CXVSCROLL);
}
//---------------------------------------------------------------------------
CDumpStatic::~CDumpStatic()
{
	ClearControl();
	if( m_pFont ){
		m_pFont->DeleteObject();
		delete m_pFont;
		m_pFont = NULL;
	}
}
//---------------------------------------------------------------------------
BOOL CDumpStatic::DestroyWindow() 
{
	if( m_nTimerID ){
		KillTimer(m_nTimerID);
		m_nTimerID = 0;
	}
	return CStatic::DestroyWindow();
}

BEGIN_MESSAGE_MAP(CDumpStatic, CStatic)
	//{{AFX_MSG_MAP(CDumpStatic)
	ON_WM_PAINT()
	ON_WM_VSCROLL()
	ON_WM_TIMER()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDumpStatic bZ[W nh
//---------------------------------------------------------------------------
void CDumpStatic::OnPaint() 
{
	CPaintDC dc(this);

	CFontSelect fs(&dc, m_pFont);
	InitControl(&dc);
	Scroll(&dc);
}
//---------------------------------------------------------------------------
void CDumpStatic::OnSize(UINT nType, int cx, int cy) 
{
	CStatic::OnSize(nType, cx, cy);
	if( (cx <= 0) || (cy <= 0) ){
		m_bIconic = TRUE;
	}
	else {
		m_bIconic = FALSE;
		InvalidateControl();
		DrawWindow();
	}
}
//---------------------------------------------------------------------------
void CDumpStatic::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	ASSERT(pScrollBar);
	int nNow = pScrollBar->GetScrollPos();
	switch(nSBCode){
		case SB_BOTTOM:	//   ԉ܂ŃXN[B
			pScrollBar->SetScrollPos(m_Count - m_LineMax + 1);
			break;
		case SB_ENDSCROLL:	//   XN[IB
			break;
		case SB_LINEDOWN:	//   1 sփXN[B
			pScrollBar->SetScrollPos(nNow + 1);
			break;
		case SB_LINEUP:		//   1 sփXN[B
			if( nNow ) pScrollBar->SetScrollPos(nNow - 1);
			break;
		case SB_PAGEDOWN:	//   1 y[WփXN[B
			pScrollBar->SetScrollPos(nNow + (m_LineMax / 2));
			break;
		case SB_PAGEUP:		//   1 y[WփXN[B
			pScrollBar->SetScrollPos(nNow - (m_LineMax / 2));
			break;
		case SB_THUMBPOSITION:	//   ΈʒuփXN[B݈ʒu nPos Œ񋟁B
			pScrollBar->SetScrollPos(nPos);
			break;
		case SB_THUMBTRACK:		//   wʒuփXN[ {bNXhbOB݈ʒu nPos Œ񋟁B
			pScrollBar->SetScrollPos(nPos);
			break;
		case SB_TOP:
			pScrollBar->SetScrollPos(0);
			break;
	}
	OnScrollBarChange();
	CStatic::OnVScroll(nSBCode, nPos, pScrollBar);
}
//---------------------------------------------------------------------------
int CDumpStatic::Strlen(const short *p)
{
	int n = 0;
	for(; *p; p++, n++ );
	return n;
}
//---------------------------------------------------------------------------
void CDumpStatic::ClearControl(void)
{
	m_Scroll = 0;
	m_Top = 0;
	m_Line = 0;
	m_Col = 0;
	m_Count = 0;
	m_WriteLine = 0;

	m_ReadLine = 0;
	m_ReadCol = 0;
	m_ColMax = 0;

	for( int i = 0; i < DUMPLINEMAX; i++ ){
		if( m_pList[i] ){
			delete m_pList[i];
			m_pList[i] = NULL;
		}
	}
	if( m_pScrollBar ){
		m_pScrollBar->DestroyWindow();
		delete m_pScrollBar;
		m_pScrollBar = NULL;
	}
	m_Init = FALSE;
}
//---------------------------------------------------------------------------
void CDumpStatic::InitControl(CDC *pDC)
{
	if( m_Init ) return;

	RECT rc;
	GetClientRect(&rc);
	if( (rc.right <= 0) || (rc.bottom <= 0) ){
		m_bIconic = TRUE;
		m_Init = m_rcClient.right ? TRUE : FALSE;
		return;
	}
	else {
		m_rcClient = rc;
		m_bIconic = FALSE;
	}
	if( m_pScrollBar ){
		rc = m_rcClient;
		rc.left = rc.right - m_CXVSCROLL;
		m_pScrollBar->MoveWindow(&rc);
	}
	else {
		m_pScrollBar = new CScrollBar;
		ASSERT(m_pScrollBar);
		m_pScrollBar->Create(WS_CHILD|WS_VISIBLE|SBS_RIGHTALIGN|SBS_VERT, m_rcClient, this, IDC_VSCROLL);
	}
	m_rcClient.right -= m_CXVSCROLL;
	if( m_rcClient.right < 0 ) m_rcClient.right = 1;
	if( m_rcClient.bottom < 0 ) m_rcClient.bottom = 1;
	m_rcDraw = m_rcClient;

	int OldColMax = m_ColMax;
	CFontSelect fs(pDC, m_pFont);
	CSize funit = pDC->GetTextExtent("M");
	fs.Release();
	m_FH = funit.cy;
	m_FW = funit.cx;
	if( !m_FH ) m_FH++;
	if( !m_FW ) m_FW++;
	m_LineMax = m_rcClient.bottom / m_FH;
	m_ColMax = m_rcClient.right / m_FW;
	if( !m_LineMax ) m_LineMax++;
	if( !m_ColMax ) m_ColMax++;

	if( m_ColMax != OldColMax ){
		int i;
		int copylen = (m_ColMax > OldColMax) ? OldColMax : m_ColMax;
		for( i = 0; i < DUMPLINEMAX; i++ ){
			if( m_pList[i] != NULL ){
				LPSHORT pw = new SHORT[m_ColMax+1];
				memcpy(pw, m_pList[i], copylen*sizeof(SHORT));
				pw[copylen] = 0;
				delete m_pList[i];
				m_pList[i] = pw;
			}
			else {
				m_pList[i] = new SHORT[m_ColMax+1];
				*m_pList[i] = SHORT(i ? -1 : 0);
			}
		}
	}
	if( m_Col >= m_ColMax ){
		m_Col = m_ColMax - 1;
	}
	if( m_Count >= m_LineMax ){
		m_Line = m_LineMax - 1;
		m_Top = AdjustPos(m_WriteLine - m_LineMax + 1);
		if( m_pScrollBar ){
			if( GetPos(m_Line+1) == m_WriteLine ){
				m_pScrollBar->SetScrollRange(0, m_Count - m_LineMax + 1);
				m_pScrollBar->SetScrollPos(m_Count - m_LineMax + 1);
				m_pScrollBar->EnableWindow(TRUE);
			}
		}
	}
	else {
		m_Line = m_WriteLine;
		m_Top = 0;
		if( m_pScrollBar ) m_pScrollBar->EnableWindow(FALSE);
	}
	m_Init = TRUE;
}
//---------------------------------------------------------------------------
int CDumpStatic::GetPos(int n)
{
	n += m_Top;
	if( n >= DUMPLINEMAX ) n -= DUMPLINEMAX;
	return n;
}
//---------------------------------------------------------------------------
int CDumpStatic::GetNext(int n)
{
	n++;
	if( n >= DUMPLINEMAX ) n = 0;
	return n;
}
//---------------------------------------------------------------------------
int CDumpStatic::AdjustPos(int n)
{
	while( n < 0 ) n+= DUMPLINEMAX;
	while( n >= DUMPLINEMAX ) n -= DUMPLINEMAX;
	return n;
}
//---------------------------------------------------------------------------
void CDumpStatic::DrawChar(CDC *pDC, int x, int y, SHORT c)
{
	if( y >= m_rcDraw.bottom ) return;
	if( x >= m_rcDraw.right ) return;
	m_rcDraw.left = x; m_rcDraw.top = y;
	COLORREF col = 0;
	if( c & 0x0100 ) col |= RGB(0,0,255);
	if( c & 0x0200 ) col |= RGB(0,255,0);
	if( c & 0x0400 ) col |= RGB(255,0,0);
	pDC->SetTextColor(col);
	pDC->DrawText((LPSTR)&c, 1, &m_rcDraw, DT_LEFT|DT_TOP);
}
//---------------------------------------------------------------------------
void CDumpStatic::OnDraw(CDC *pDC)
{
	if( !IsWindowVisible() || !m_Init || !pDC || m_bIconic ) return;

	CursorOff(pDC);
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetBkColor(m_clBack);
	int i, j, x, y;
	LPSHORT	pw;
	for( y = i = 0; i <= m_Line; i++, y += m_FH ){
		pw = m_pList[GetPos(i)];
		if( *pw != -1 ){
			for( x = j = 0; j < m_ColMax; j++, x += m_FW, pw++ ){
				if( *pw ){
					DrawChar(pDC, x, y, *pw);
				}
				else {
					break;
				}
			}
		}
		else {
			break;
		}
	}
	CursorOn(pDC);
}
//---------------------------------------------------------------------------
void CDumpStatic::IncCount(void)
{
	m_WriteLine = GetNext(m_WriteLine);
	*(m_pList[m_WriteLine]) = 0;
	*(m_pList[GetNext(m_WriteLine)]) = -1;
	if( m_Count < DUMPLINEMAX ){
		m_Count++;
		if( m_pScrollBar && (m_Count >= m_LineMax) ){
			if( GetPos(m_Line+1) == m_WriteLine ){
				m_pScrollBar->SetScrollRange(0, m_Count - m_LineMax + 1);
				m_pScrollBar->SetScrollPos(m_Count - m_LineMax + 1);
				m_pScrollBar->EnableWindow(TRUE);
			}
		}
	}
	if( m_Count >= m_LineMax ){
		if( GetPos(m_Line+1) == m_WriteLine ){
			m_Top = GetNext(m_Top);
		}
	}
}
//---------------------------------------------------------------------------
void CDumpStatic::Scroll(CDC *pDC)
{
	if( !IsWindowVisible() || !m_Init || m_bIconic ) return;

	if( pDC ){
		pDC->FillSolidRect(&m_rcClient, (GetPos(m_Line) == m_WriteLine) ? m_clBack : RGB(192,192,192));
		OnDraw(pDC);
	}
}
//---------------------------------------------------------------------------
void CDumpStatic::OnScrollBarChange(void)
{
	ASSERT(m_pScrollBar);
	if( !m_pScrollBar ) return;

	int pos, max;
	m_pScrollBar->GetScrollRange(&pos, &max);
	pos = m_pScrollBar->GetScrollPos();

	int n = max - pos;
	if( n > (DUMPLINEMAX - m_LineMax - 1) ) n = DUMPLINEMAX - m_LineMax - 1;
	m_Top = m_WriteLine - m_LineMax - n + 1;
	while( m_Top < 0 ) m_Top += DUMPLINEMAX;
	while( m_Top >= DUMPLINEMAX ) m_Top -= DUMPLINEMAX;
	if( max == pos ){
		max = m_Count - m_LineMax + 1;
		m_pScrollBar->SetScrollRange(0, max);
		m_pScrollBar->SetScrollPos(max);
	}
	DrawWindow();
}
//---------------------------------------------------------------------------
void CDumpStatic::DrawWindow(void)
{
	if( !IsWindowVisible() ) return;

	CClientDC dc(this);
	CFontSelect fs(&dc, m_pFont);
	InitControl(&dc);
	if( !m_bIconic ) Scroll(&dc);
}
//---------------------------------------------------------------------------
void CDumpStatic::PutChar(CDC *pDC, char c, int col)
{
	if( !m_Init ) return;

	BOOL show = (GetPos(m_Line) == m_WriteLine);
	CursorOff(pDC);
	if( pDC ) pDC->SetBkMode(TRANSPARENT);
	if( show && (c == 0x08) ){			// BS̎
		if( BackSpace(pDC) || (!m_ReadLine && !m_ReadCol) ){
			CursorOn(pDC);
			return;
		}
		c = 'X';
	}
	if( c == '\n' ){
		if( !m_bEdit ){
			if( m_Scroll != 'o' ){
				IncCount();
				m_Col = 0;
				if( show ){
					m_Line++;
					if( m_Line >= m_LineMax ){
						m_Line--;
						Scroll(pDC);
					}
					m_Scroll = c;
				}
			}
			else {
				m_Scroll = 0;
			}
		}
	}
	else if( c == '\r' ){
		if( m_bEdit ){
			IncCount();
			m_Col = 0;
			if( show ){
				m_Line++;
				if( m_Line >= m_LineMax ){
					m_Line--;
					Scroll(pDC);
				}
				m_Scroll = 0;
			}
		}
		else if( m_Scroll != 'o' ){
			m_Col = 0;
			m_Scroll = c;
		}
	}
	else if( c ){
		if( m_Scroll ){
			if( m_Scroll == '\r' ){
				PutChar(pDC, '\n', col);
				CursorOff(pDC);
				m_Scroll = 0;
			}
			m_Col = 0;
			m_Scroll = 0;
		}
		LPSHORT pw = m_pList[m_WriteLine] + m_Col;
		*pw = SHORT(c | (col << 8));
		*(pw+1) = 0;
		if( show && (pDC != NULL) ){
			DrawChar(pDC, m_Col * m_FW, m_Line * m_FH, *pw); 
		}
		m_Col++;
		if( m_Col >= m_ColMax ){
			m_Col = 0;
			IncCount();
			if( show ){
				m_Line++;
				if( m_Line >= m_LineMax ){
					m_Line--;
					Scroll(pDC);
				}
				m_Scroll = 'o';
			}
		}
	}
	CursorOn(pDC);
}
//---------------------------------------------------------------------------
void CDumpStatic::PutChar(char c, int col)
{
	if( IsWindowVisible() && !m_bIconic ){
		CClientDC dc(this);
		InitControl(&dc);
		if( !m_Init ) return;
		CFontSelect fs(&dc, m_pFont);
		PutChar(&dc, c, col);
	}
	else if( m_Init ){
		PutChar(NULL, c, col);
	}
}
//---------------------------------------------------------------------------
void CDumpStatic::PutText(LPCSTR p, int col)
{
	while(*p) PutChar(*p++, col);
}
//---------------------------------------------------------------------------
void CDumpStatic::PutStatus(LPCSTR p, int col)
{
	if( m_Col ) PutChar('\r', col);
	while(*p) PutChar(*p++, col);
	PutChar('\n', col);
}
//---------------------------------------------------------------------------
void CDumpStatic::Clear(void)
{
	ClearControl();
	if( IsWindowVisible() && !m_bIconic ){
		CClientDC dc(this);
		CFontSelect(&dc, m_pFont);
		InitControl(&dc);
		Scroll(&dc);
	}
}
//---------------------------------------------------------------------------
void CDumpStatic::CursorOff(CDC *pDC)
{
	if( m_Cursor && m_CursorF ){
		DrawCursor(pDC, 0);
	}
}
//---------------------------------------------------------------------------
void CDumpStatic::CursorOn(CDC *pDC)
{
	if( m_Cursor && !m_CursorF ){
		DrawCursor(pDC, 1);
	}
}
//---------------------------------------------------------------------------
void CDumpStatic::DrawCursor(CDC *pDC, int sw)
{
	if( !pDC ) return;
	if( GetPos(m_Line) != m_WriteLine ) return;

	m_CursorF = sw;
	RECT rc;

	rc.left = m_Col * m_FW + 1;
	rc.right = rc.left + m_FW - 1;
	rc.bottom = (m_Line * m_FH) + m_FH - 1;
	rc.top = rc.bottom - 3;

	if( sw ){
		pDC->FillSolidRect(&rc, m_Cursor == csBLINK ? RGB(0,0,0) : RGB(192,192,192));
	}
	else {
		pDC->FillSolidRect(&rc, m_clBack);
		if( (m_pList[m_WriteLine] != NULL) && (*m_pList[m_WriteLine]!=-1) ){
			LPSHORT pw = m_pList[m_WriteLine];
			LPSHORT pwl = pw;
			int i;
			for( i = 0; *pwl & 0x00ff; pwl++, i++ );
			if( i > m_Col ){
				DrawChar(pDC, m_Col * m_FW, m_Line * m_FH, pw[m_Col]);
			}
		}
	}
}
//---------------------------------------------------------------------------
void CDumpStatic::SetCursor(int sw)
{
	if( m_Cursor != sw ){
		m_CursorF = FALSE;
		if( IsWindowVisible() && !m_bIconic ){
			CClientDC dc(this);
			CFontSelect fs(&dc, m_pFont);
			InitControl(&dc);
			DrawCursor(&dc, sw);
		}
		m_Cursor = sw;
		if( sw == csBLINK ){
			if( !m_nTimerID ){
				m_nTimerID = SetTimer(1, 500, NULL);
			}
		}
		else if( m_nTimerID ){
			KillTimer(m_nTimerID);
			m_nTimerID = 0;
		}
	}
}
//---------------------------------------------------------------------------
void CDumpStatic::OnTimer(UINT nIDEvent) 
{
	if( m_nTimerID == nIDEvent ){
		if( IsWindowVisible() && m_Init && !m_bIconic ){
			CClientDC dc(this);
			CFontSelect fs(&dc, m_pFont);
			InitControl(&dc);
			if( m_CursorF ){
				CursorOff(&dc);
			}
			else {
				CursorOn(&dc);
			}
		}
	}
	CStatic::OnTimer(nIDEvent);
}
//---------------------------------------------------------------
// 肾\ȕ𓾂
int CDumpStatic::GetLen(void)
{
	int mr = m_ReadLine;
	int n = 0;
	while(mr < m_WriteLine){
		n += Strlen(m_pList[mr]) + 1;
		mr++;
	}
	n += (m_Col - m_ReadCol);
	return n;
}
//---------------------------------------------------------------
// Ō̕𓾂
char CDumpStatic::GetLastChar(void)
{
	if( m_ReadLine > m_WriteLine ) return 0;		// oȂ
	if( m_ReadLine == m_WriteLine ){				// s̎
		if( m_Col <= m_ReadCol ) return 0; 			// oȂ
	}
	if( !m_Col ) return 0x0a;

	LPSHORT pw = m_pList[m_WriteLine];
	pw += m_Col - 1;
	return *pw & 0x00ff;
}
//---------------------------------------------------------------
// 擪̈ꕶo
char CDumpStatic::GetChar(void)
{
	LPSHORT pw;
	char c;

	if( m_ReadLine > m_WriteLine ) return -1;		// oȂ
	if( m_ReadLine == m_WriteLine ){				// s̎
		if( m_Col <= m_ReadCol ) return -1; 		// oȂ
	}

	pw = m_pList[m_ReadLine];
	pw += m_ReadCol;

	if( !*pw ){		// s
		if( m_ReadCol ){
			c = *(pw-1) & 0x00ff;
			if( ((c == '_')||(c == '~')) && (m_ReadCol == m_ColMax) ){
				m_ReadLine = GetNext(m_ReadLine);
				m_ReadCol = 0;
				return 0;
			}
		}
		c = 0x0d;
		m_ReadLine = GetNext(m_ReadLine);
		m_ReadCol = 0;
	}
	else {
		c = *pw & 0x00ff;
		*pw = (*pw & 0x00ff) | 0x0400;
		if( (m_ReadLine >= GetPos(0)) && (m_ReadLine <= (GetPos(0) + m_LineMax - 1)) ){
			if( IsWindowVisible() ){
				CClientDC dc(this);
				CFontSelect fs(&dc, m_pFont);
				InitControl(&dc);
				DrawChar(&dc, m_ReadCol * m_FW, (m_ReadLine - GetPos(0)) * m_FH, *pw);
			}
		}
		m_ReadCol++;
	}
	return c;
}
//---------------------------------------------------------------
// obNXy[X
int CDumpStatic::BackSpace(CDC *pDC)
{
	if( m_ReadLine > m_WriteLine ) return FALSE;	// oȂ
	if( m_ReadLine == m_WriteLine ){				// s̎
		if( m_Col <= m_ReadCol ) return FALSE; 		// oȂ
	}
	if( m_Col ){
		m_Col--;
	}
	else {
		m_WriteLine--;
		if( m_Top ){
			m_Top--;
		}
		else if( m_Line ){
			m_Line--;
		}
		if( m_Count ) m_Count--;
		m_Col = Strlen(m_pList[m_WriteLine]);
		if( m_Col >= m_ColMax ) m_Col--;
		UpdateScroll();
	}
	LPSHORT pw = m_pList[m_WriteLine];
	pw += m_Col;
	*pw = 0;
	Scroll(pDC);
	return TRUE;
}
//---------------------------------------------------------------
// XN[o[̍XV
void CDumpStatic::UpdateScroll(void)
{
	if( m_WriteLine >= m_LineMax ){
		m_pScrollBar->SetScrollRange(0, m_Count - m_LineMax + 1);
		m_pScrollBar->SetScrollPos(m_Count - m_LineMax + 1);
		m_pScrollBar->EnableWindow(TRUE);
	}
	else if( m_pScrollBar->IsWindowEnabled() ){
		m_pScrollBar->EnableWindow(FALSE);
	}
}
