// ImageStatic.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "RemMFC.h"
#include "IStatic.h"
#include "RemMFCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImageStatic    JX^Rg[

IMPLEMENT_DYNAMIC(CImageStatic, CStatic)

CImageStatic::CImageStatic()
{
	m_hBitmap = NULL;
	m_pDlg = NULL;
	m_prcValid = NULL;
	m_prcDraw = NULL;
	m_clBack = RGB(0,0,0);
	m_CursorY = -1;
	memset(&m_rcClient, 0, sizeof(m_rcClient));
}

CImageStatic::~CImageStatic()
{
}


BEGIN_MESSAGE_MAP(CImageStatic, CStatic)
	//{{AFX_MSG_MAP(CImageStatic)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImageStatic
void CImageStatic::SetBitmap(HBITMAP hBitmap, LPRECT prcValid, COLORREF clBack)
{
	m_hBitmap = hBitmap;
	m_prcValid = prcValid;
	m_clBack = clBack;
	if( prcValid && ((prcValid->bottom < m_rcClient.bottom) || (prcValid->right < m_rcClient.right)) ){
		m_prcDraw = prcValid;
	}
	else {
		m_prcDraw = &m_rcClient;
	}
	Draw(TRUE);
}
//---------------------------------------------------------------------------
void CImageStatic::Initialize(void)
{
	if( !m_rcClient.right ) InitialUpdate(NULL);
}
//---------------------------------------------------------------------------
void CImageStatic::InitialUpdate(CRemMFCDlg *pDlg)
{
	m_pDlg = pDlg;
	GetClientRect(&m_rcClient);
	m_rcMouse = m_rcClient;
	m_prcDraw = &m_rcClient;
}
//---------------------------------------------------------------------------
int CImageStatic::GetXW(void)
{
	Initialize();
	ASSERT(m_rcClient.right);
	return m_rcClient.right;
}
int CImageStatic::GetYW(void)
{
	Initialize();
	ASSERT(m_rcClient.bottom);
	return m_rcClient.bottom;
}
//---------------------------------------------------------------------------
void CImageStatic::SetClientSize(LPRECT prcBase, int xw, int yw)
{
	MoveWindow(prcBase);
	InitialUpdate(NULL);
	int xd = xw - m_rcClient.right;
	int yd = yw - m_rcClient.bottom;
	if( xd || yd ){
		prcBase->right += xd;
		prcBase->bottom += yd;
		MoveWindow(prcBase);
		GetClientRect(&m_rcClient);
		VERIFY((m_rcClient.right == xw)&&(m_rcClient.bottom == yw));
	}
}
//---------------------------------------------------------------------------
void CImageStatic::OnDraw(CDC *pDC, BOOL bRedraw)
{
	if( !m_hBitmap ) return;

	VERIFY(pDC->GetMapMode() == MM_TEXT);
	Initialize();
	if( bRedraw && (m_prcDraw != &m_rcClient) ) pDC->FillSolidRect(&m_rcClient, m_clBack);
	DrawBitmap(pDC->m_hDC, m_prcDraw, m_hBitmap, m_prcValid, HALFTONE);
	m_CursorY = -1;
}
//---------------------------------------------------------------------------
void CImageStatic::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	OnDraw(&dc, TRUE);
}
//---------------------------------------------------------------------------
void CImageStatic::Draw(BOOL bRedraw)
{
	if( !IsWindowVisible() ) return;

	CClientDC dc(this);
	OnDraw(&dc, bRedraw);
}
//---------------------------------------------------------------------------
void CImageStatic::DrawLineCursor(int y)
{
    m_CursorY = y;

	CClientDC dc(this);
	dc.MoveTo(0, y);
	int op2 = dc.SetROP2(R2_NOT);
	dc.LineTo(m_rcClient.right, y);
	dc.SetROP2(op2);
}
//---------------------------------------------------------------------------
void CImageStatic::DrawLineCursor(int sw, int sy)
{
	if( !IsWindowVisible() ) return;

    if( sw ){
        if( (m_CursorY < 0) || (m_CursorY != sy) ){
            if( m_CursorY >= 0 ) DrawLineCursor(m_CursorY);
            DrawLineCursor(sy);
        }
    }
    else {
		Invalidate();
    }
}
//---------------------------------------------------------------------------
void CImageStatic::NotifyMouse(UINT code, const CPoint &point) 
{
	m_rcMouse.left = point.x;
	m_rcMouse.top = point.y;
	
	m_pDlg->OnImageMouse(this, code, &m_rcMouse);
}
//---------------------------------------------------------------------------
void CImageStatic::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if( m_pDlg && (nFlags == MK_LBUTTON) ){
		SetCapture();
		NotifyMouse(IS_LDOWN, point);
	}
	CStatic::OnLButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------
void CImageStatic::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if( m_pDlg && (GetCapture() == this) ){
		ReleaseCapture();
		NotifyMouse(IS_LUP, point);
	}
	CStatic::OnLButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------
void CImageStatic::OnMouseMove(UINT nFlags, CPoint point) 
{
	if( m_pDlg && (GetCapture() == this) ){
		if( nFlags & MK_LBUTTON ){
			NotifyMouse(IS_LMOVE, point);
		}
		else if( nFlags & MK_RBUTTON ){
			NotifyMouse(IS_RMOVE, point);
		}
	}
	CStatic::OnMouseMove(nFlags, point);
}
//---------------------------------------------------------------------------
void CImageStatic::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if( m_pDlg ){
		SetCapture();
		NotifyMouse(IS_RDOWN, point);
	}
	CStatic::OnRButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------
void CImageStatic::OnRButtonUp(UINT nFlags, CPoint point) 
{
	if( m_pDlg && (GetCapture() == this) ){
		ReleaseCapture();
		NotifyMouse(IS_RUP, point);
	}
	CStatic::OnRButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------
void CImageStatic::DrawBitmap(HDC hDC, LPRECT prcDest, HBITMAP hb, LPRECT prcSrc, LONG smode)
{
    if( hDC == NULL ) return;
    RECT src, trc;
    if( prcSrc == NULL ){
        BITMAP bmp;
        if( !GetObject(hb, sizeof(BITMAP), &bmp) ) return;
        prcSrc = &src;
        prcSrc->left = prcSrc->top = 0;
        prcSrc->right = bmp.bmWidth;
        prcSrc->bottom = bmp.bmHeight;
    }
    if( prcDest == NULL ){
        prcDest = &trc;
        prcDest->left = prcDest->top = 0;
        prcDest->right = prcSrc->right;
        prcDest->bottom = prcSrc->bottom;
    }
    int sxw = prcSrc->right - prcSrc->left;
    int syw = prcSrc->bottom - prcSrc->top;
    int txw = prcDest->right - prcDest->left;
    int tyw = prcDest->bottom - prcDest->top;

	HDC hdcSrc = ::CreateCompatibleDC(hDC);
	HBITMAP hbOld = (HBITMAP)::SelectObject(hdcSrc, hb);
    if( (sxw != txw) || (syw != tyw) ){
        smode = ::SetStretchBltMode(hDC, smode);
        ::StretchBlt(hDC, prcDest->left, prcDest->top, txw, tyw,
	    	hdcSrc, prcSrc->left, prcSrc->top, sxw, syw, SRCCOPY);
        ::SetStretchBltMode(hDC, smode);
    }
    else {
        ::BitBlt(hDC, prcDest->left, prcDest->top, sxw, syw,
	    	hdcSrc, prcSrc->left, prcSrc->top, SRCCOPY);
    }
	::SelectObject(hdcSrc, hbOld);
	::DeleteDC(hdcSrc);
}

