// RemMFCDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "RemMFC.h"
#include "RemMFCDlg.h"
#include "EDialog.h"
#include "IDialog.h"
#include "Filter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSplitter class

CSplitter::CSplitter()
{
	m_pWnd = NULL;
	m_edge = 5;
	m_minsize = 24;
	m_hCursor[0] = GetApp()->LoadStandardCursor(IDC_ARROW);
	m_hCursor[1] = GetApp()->LoadStandardCursor(IDC_SIZENS);
}
BOOL CSplitter::Create(CWnd *pWnd, int splitter, int top, int bottom, int minsize)
{
	m_minsize = minsize;
	m_pWnd = pWnd;
	m_splitter = splitter;
	if( m_splitter < 0 ) m_splitter = (top + bottom) / 2;
	SetRange(top, bottom);
	return TRUE;
}
void CSplitter::SetRange(int top, int bottom)
{
	m_top = top + m_minsize;
	m_bottom = bottom - m_minsize;
	if( m_splitter < m_top ) m_splitter = m_top;
	if( m_splitter > m_bottom ) m_splitter = m_bottom;
}
BOOL CSplitter::HitTest(CPoint &point)
{
	return ( (point.y > (m_splitter - m_edge)) && (point.y < (m_splitter + m_edge)) );
}
int CSplitter::OnMouseMove(CPoint &point)
{
	int r = FALSE;
	if( !m_pWnd ) return r;
	int index = 0;
	if( m_pWnd->GetCapture() == m_pWnd ){
		index = 1;
		if( (point.y > m_top) && (point.y < m_bottom) ){
			m_splitter = point.y;
			r = TRUE;
		}
	}
	else if( HitTest(point) ){
		index = 1;
	}
	::SetCursor(m_hCursor[index]);
	return r;
}
void CSplitter::OnLButtonDown(CPoint &point)
{
	if( !m_pWnd ) return;
	if( HitTest(point) ){
		m_pWnd->SetCapture();
		::SetCursor(m_hCursor[1]);
	}
}
void CSplitter::OnLButtonUp(CPoint &point) 
{
	if( !m_pWnd ) return;
	if( m_pWnd->GetCapture() == m_pWnd ){
		ReleaseCapture();
	}
}

/////////////////////////////////////////////////////////////////////////////
void Multi2Single(CString &ts, const CString &cs)
{
	ts = "";
	LPCSTR p = cs;
	for( ; *p; p++ ){
		switch(*p){
			case '\\':
				ts += "\\\\";
				break;
			case '\r':
				ts += '\\';
				ts += 'r';
				break;
			case '\n':
				ts += '\\';
				ts += 'n';
				break;
			case '\t':
				ts += '\\';
				ts += 't';
				break;
			default:
				if( *p >= ' ' ) ts += *p;
		}
	}
}
void Single2Multi(CString &ts, const CString &cs)
{
	ts = "";
	LPCSTR p = cs;
	for( ; *p; p++ ){
		switch(*p){
			case '\\':
				p++;
				switch(*p){
					case 'r':
						ts += '\r';
						break;
					case 'n':
						ts += '\n';
						break;
					case 't':
						ts += '\t';
						break;
					default:
						ts += '\\';
						break;
				}
				break;
			default:
				ts += *p;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRemMFCDlg _CAO

CRemMFCDlg::CRemMFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRemMFCDlg::IDD, pParent)
{
	memset(&m_NMmtty, 0, sizeof(m_NMmtty));
	memset(&m_rcClient, 0, sizeof(m_rcClient));
	m_ptt = FALSE;
	m_SpecBase = 250;
	m_SpecWidth = 2500;
	m_Shift = 170;
	m_NMmtty.m_markfreq = 2125;
	m_NMmtty.m_spacefreq = m_NMmtty.m_markfreq + m_Shift;
	m_pIX = NULL;
	m_pIY = NULL;
	m_bAutoSpectram = TRUE;
	m_bHighXyQuality = FALSE;
	m_bShowXyScope = TRUE;
	m_bCaptureSpectram = FALSE;

	m_InvokeCommand = "MMTTY.EXE -m";
	m_bConnected = FALSE;
	m_hMMWnd = HWND_BROADCAST;
	m_hComFile = NULL;
	m_pCom = NULL;
	m_Wait = 0;

	//{{AFX_DATA_INIT(CRemMFCDlg)
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRemMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRemMFCDlg)
	DDX_Control(pDX, IDC_TX, m_DlgTXW);
	DDX_Control(pDX, IDC_SHIFT, m_DlgShift);
	DDX_Control(pDX, IDC_TYPE, m_DlgTYPE);
	DDX_Control(pDX, IDC_UOS, m_DlgUOS);
	DDX_Control(pDX, IDC_LMS, m_DlgLMS);
	DDX_Control(pDX, IDC_BPF, m_DlgBPF);
	DDX_Control(pDX, IDC_SQ, m_DlgSQ);
	DDX_Control(pDX, IDC_REV, m_DlgREV);
	DDX_Control(pDX, IDC_ATC, m_DlgATC);
	DDX_Control(pDX, IDC_NET, m_DlgNET);
	DDX_Control(pDX, IDC_AFC, m_DlgAFC);
	DDX_Control(pDX, IDC_HAM, m_DlgHAM);
	DDX_Control(pDX, IDC_XY, m_DlgXY);
	DDX_Control(pDX, IDC_LEVEL, m_DlgLevel);
	DDX_Control(pDX, IDC_SPECTRAM, m_DlgSpectram);
	DDX_Control(pDX, IDC_BM4, m_DlgM4);
	DDX_Control(pDX, IDC_BM3, m_DlgM3);
	DDX_Control(pDX, IDC_BM2, m_DlgM2);
	DDX_Control(pDX, IDC_BM1, m_DlgM1);
	DDX_Control(pDX, IDC_BTXOFF, m_DlgTXOFF);
	DDX_Control(pDX, IDC_BTX, m_DlgTX);
	DDX_Control(pDX, IDC_NGROUP, m_DlgNGroup);
	DDX_Control(pDX, IDC_RX, m_DlgConsole);
	DDX_Control(pDX, IDC_NSTATUS, m_DlgNStatus);
	//}}AFX_DATA_MAP
}

const UINT gMsgMmtty=::RegisterWindowMessage("MMTTY");

BEGIN_MESSAGE_MAP(CRemMFCDlg, CDialog)
	//{{AFX_MSG_MAP(CRemMFCDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_BTX, OnBtx)
	ON_BN_CLICKED(IDC_BTXOFF, OnBtxoff)
	ON_COMMAND(ID_FILE_SEND, OnFileSend)
	ON_BN_CLICKED(IDC_BM1, OnBm1)
	ON_BN_CLICKED(IDC_BM2, OnBm2)
	ON_BN_CLICKED(IDC_BM3, OnBm3)
	ON_BN_CLICKED(IDC_BM4, OnBm4)
	ON_BN_CLICKED(IDC_AFC, OnAfc)
	ON_BN_CLICKED(IDC_NET, OnNet)
	ON_BN_CLICKED(IDC_HAM, OnHam)
	ON_BN_CLICKED(IDC_ATC, OnAtc)
	ON_BN_CLICKED(IDC_BPF, OnBpf)
	ON_BN_CLICKED(IDC_LMS, OnLms)
	ON_BN_CLICKED(IDC_REV, OnRev)
	ON_BN_CLICKED(IDC_SQ, OnSq)
	ON_BN_CLICKED(IDC_TYPE, OnType)
	ON_BN_CLICKED(IDC_UOS, OnUos)
	ON_COMMAND(ID_VIEW_SPECTRAM_AUTO, OnViewSpectramAuto)
	ON_COMMAND(ID_VIEW_SPECTRAM_WIDE, OnViewSpectramWide)
	ON_CBN_SELCHANGE(IDC_SHIFT, OnSelchangeShift)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_VIEW_XYSCOPE, OnViewXyscope)
	ON_COMMAND(ID_VIEW_HIGHXYQUALITY, OnViewHighxyquality)
	ON_COMMAND(ID_OPTION_SETUP, OnOptionSetup)
	ON_COMMAND(ID_OPTION_RECONNECT, OnOptionReconnect)
	ON_COMMAND(ID_OPTION_INVOKE, OnOptionInvoke)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(gMsgMmtty, OnMmttyMessage )
	ON_WM_ACTIVATE()
	ON_WM_INITMENUPOPUP()
	ON_WM_MENUSELECT()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRemMFCDlg

BOOL CRemMFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	// JX^Rg[DDX_ControlɂɃTuNXĂ܂B
	// DDX_ControlgȂꍇ͂ŊeRg[̃o֐
	// SubclassDlgItemĂяo܂B

	// }EX{^ꂽAOnImageMousenhĂяo܂B
	m_DlgSpectram.InitialUpdate(this);
	m_DlgLevel.InitialUpdate(this);

	// XyNg/XYXR[v/x\pDDB쐬܂
	memset(&m_rcSpectram, 0, sizeof(m_rcSpectram));
	memset(&m_rcLevel, 0, sizeof(m_rcLevel));
	memset(&m_rcXY, 0, sizeof(m_rcXY));
	m_rcSpectram.right = m_DlgSpectram.GetXW();
	m_rcSpectram.bottom = m_DlgSpectram.GetYW();
	m_rcLevel.right = m_DlgLevel.GetXW();
	m_rcLevel.bottom = m_DlgLevel.GetYW();
	m_rcXY.right = m_DlgXY.GetXW();
	m_rcXY.bottom = m_DlgXY.GetYW();
	CDC *pDC = GetDC();
	m_bmpSpectram.CreateCompatibleBitmap(pDC, m_rcSpectram.right, m_rcSpectram.bottom);
	m_bmpLevel.CreateCompatibleBitmap(pDC, m_rcLevel.right, m_rcLevel.bottom);
	m_bmpXY.CreateCompatibleBitmap(pDC, m_rcXY.right, m_rcXY.bottom);
	ReleaseDC(pDC);

	// ImageStaticɍ쐬DDBѕt܂
	m_DlgSpectram.SetBitmap(m_bmpSpectram, &m_rcSpectram, RGB(0,0,0));
	m_DlgLevel.SetBitmap(m_bmpLevel, &m_rcLevel, RGB(0,0,0));
	m_DlgXY.SetBitmap(m_bmpXY, &m_rcXY, RGB(0,0,0));

	// E}EX{^ꂽAOnToggleRClicknhĂяo܂B
	m_DlgM1.InitialUpdate(this);
	m_DlgM2.InitialUpdate(this);
	m_DlgM3.InitialUpdate(this);
	m_DlgM4.InitialUpdate(this);
	m_DlgLMS.InitialUpdate(this);

	// {^̃gO֎~ʂ̃{^ɂ܂BCToggleButton
	// ftHgŃgOɂȂĂ܂B
	m_DlgM1.EnableToggle(FALSE);
	m_DlgM2.EnableToggle(FALSE);
	m_DlgM3.EnableToggle(FALSE);
	m_DlgM4.EnableToggle(FALSE);
	m_DlgTXOFF.EnableToggle(FALSE);
	m_DlgTYPE.EnableToggle(FALSE);
	m_DlgHAM.EnableToggle(FALSE);

	m_DlgTX.SetTextColor(RGB(255,0,0));

	// vt@C珉lǂݏo܂B
	CRemMFCApp *pApp = GetApp();
	ASSERT(pApp);
	pApp->RegisterMainWindow(m_hWnd);

	m_InvokeCommand = pApp->GetProfileString("MMTTY", "Invoke", m_InvokeCommand);

	m_Msg[0] = "\r\n CQ CQ CQ DE SAMPLE SAMPLE SAMPLE PSE K\r\n\\";
	m_Msg[1] = "\r\n QSL UR 599 25 599 25 BK\r\n\\";
	m_Msg[2] = "\r\n AGN NR??\r\n\\";
	m_Msg[3] = "\r\n TNX CUL, 73 DE SAMPLE QRZ?\r\n\\";
	for( int i = 0; i < 4; i++ ){
		CString key;
		key.Format("M%u", i+1);
		CString cs;
		Multi2Single(cs, m_Msg[i]);
		cs = pApp->GetProfileString("Messages", key, cs);
		Single2Multi(m_Msg[i], cs);
	}
	m_bAutoSpectram = pApp->GetProfileInt("View", "AutoSpectram", m_bAutoSpectram);
	m_bHighXyQuality = pApp->GetProfileInt("View", "HighXyQuality", m_bHighXyQuality);

	RECT rc;
	rc.left = pApp->GetProfileInt("Window", "Left", 100);
	rc.top = pApp->GetProfileInt("Window", "Top", 50);
	if( rc.left < -200 ) rc.left = 0;
	if( rc.top < -100 ) rc.top = 0;
	rc.right = pApp->GetProfileInt("Window", "Width", 600);
	rc.bottom = pApp->GetProfileInt("Window", "Height", 400);
	::SetWindowPos(m_hWnd, HWND_TOPMOST, rc.left, rc.top, rc.right, rc.bottom, SWP_NOZORDER);
	ShowWindow(SW_SHOW);
	GetClientRect(&m_rcClient);
	m_DlgNGroup.GetClientRect(&m_rcGroup);
	m_rcGroup.bottom += 2;
	m_Splitter.Create(this, m_rcGroup.bottom + (m_rcClient.bottom - m_rcGroup.bottom)*2/3, m_rcGroup.bottom, m_rcClient.bottom, 24);

	UpdateItemSize();
	m_DlgConsole.SetCursor(csON);
	m_DlgTXW.EnableEdit(TRUE);	// BSҏW܂
	m_DlgTXW.SetCursor(csBLINK);
	CString cs;
	cs.Format("%d", m_Shift);
	m_DlgShift.SetWindowText(cs);
	UpdateSpectramWidth();
	OnDrawXY(NULL);
	DrawLevel();
	GetApp()->HookKeyMessage(TRUE);
	OpenMmtty();
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}
//---------------------------------------------------------------------------
BOOL CRemMFCDlg::DestroyWindow() 
{
	CloseMmtty(FALSE);
	// vt@Cɕۑ܂B
	CRemMFCApp *pApp = GetApp();
	ASSERT(pApp);
	pApp->WriteProfileString("MMTTY", "Invoke", m_InvokeCommand);

	if( !IsIconic() && !IsZoomed() ){
		RECT rc;
		GetWindowRect(&rc);
		pApp->WriteProfileInt("Window", "Left", rc.left);
		pApp->WriteProfileInt("Window", "Top", rc.top);
		pApp->WriteProfileInt("Window", "Width", rc.right - rc.left);
		pApp->WriteProfileInt("Window", "Height", rc.bottom - rc.top);
	}
	for( int i = 0; i < 4; i++ ){
		CString key;
		key.Format("M%u", i+1);
		CString cs;
		Multi2Single(cs, m_Msg[i]);
		pApp->WriteProfileString("Messages", key, cs);
	}
	pApp->WriteProfileInt("View", "AutoSpectram", m_bAutoSpectram);
	pApp->WriteProfileInt("View", "HighXyQuality", m_bHighXyQuality);

	DeleteIXY();
	m_DlgConsole.DestroyWindow();
	m_DlgTXW.DestroyWindow();
	m_bmpSpectram.DeleteObject();
	m_bmpXY.DeleteObject();
	m_bmpLevel.DeleteObject();
	return CDialog::DestroyWindow();
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnPaint() 
{
	if(IsIconic()){
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else {
		CDialog::OnPaint();
	}
}
HCURSOR CRemMFCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//---------------------------------------------------------------------------
//	NXe[^X\܂B
void CRemMFCDlg::DispStatus(void)
{
	COLORREF col;
	char bf[128];
	if( !m_hComFile ){
		CString cs;
		cs.LoadString(IDS_FILEMAPPING_CREATION_FAILED);
		strcpy(bf, cs);
		col = RGB(255,0,0);
	}
	else if( m_bConnected ){
		wsprintf(bf, "Connected to MMTTY %s", m_pCom ? m_pCom->verMMTTY : "???");
		col = RGB(0,255,0);
	}
	else {
		strcpy(bf, "Disconnected");
		col = RGB(255,0,0);
	}
	m_DlgNStatus.SetWindowText(bf, col);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OpenMmtty(void)
{
	CloseMmtty(TRUE);
	m_hMMWnd = HWND_BROADCAST;
	// LANZX̃t@C}bsO쐬܂B
	m_hComFile = (HANDLE)::CreateFileMapping(HANDLE(0xffffffff), NULL, PAGE_READWRITE, 0, sizeof(COMARRAY), "MMTTY");
	VERIFY(GetLastError() != ERROR_ALREADY_EXISTS);
	if( m_hComFile && (m_pCom = (COMARRAY *)::MapViewOfFile(m_hComFile, FILE_MAP_WRITE, 0, 0, 0))!=NULL ){
		// L܂B
		memset(m_pCom, 0, sizeof(COMARRAY));
		strcpy(m_pCom->title, "MiniMFC/MMTTY engine");
		// MMTTYN܂B
		m_DlgNStatus.SetWindowText("Invoking MMTTY", RGB(255,255,0));
		::WinExec(m_InvokeCommand, SW_SHOW);
	}
	else {
		if( m_hComFile ){
			CloseHandle(m_hComFile);
			m_hComFile = NULL;
		}
		DispStatus();
		AfxMessageBox(IDS_FILEMAPPING_CREATION_FAILED);
	}
}
//---------------------------------------------------------------------------
void CRemMFCDlg::CloseMmtty(BOOL bWait)
{
	HWND hWnd = (m_hMMWnd != HWND_BROADCAST) ? m_hMMWnd : ::FindWindow("TMmttyWd", NULL);
	if( hWnd ){
		// X^hA[ŋNĂ邩Ȃ̂ŁA
		// WM_CLOSE𑗂ďI܂B
		m_DlgNStatus.SetWindowText("Process is closing MMTTY...", RGB(255,255,0));
		::SendMessage(hWnd, WM_CLOSE, 0, 0);
	}
	if( bWait && hWnd ){
		// MMTTYSɏI܂ő҂܂B
		int i;
		for( i = 0; (i < 500) && ::FindWindow("TMmttyWd", NULL); i++ ){
			::Sleep(10);
			if( !ProcessMessages() ) break;
		}
		if( i == 500 ){
			AfxMessageBox(IDS_MMTTY_CLOSE_FAILED);
		}
	}
	m_hMMWnd = HWND_BROADCAST;
	m_bConnected = FALSE;
	DispStatus();
	if( m_hComFile ){
		if( m_pCom ){
			::UnmapViewOfFile(m_pCom);
			m_pCom = NULL;
		}
		CloseHandle(m_hComFile);
		m_hComFile = NULL;
	}
	DeleteIXY();
}
//---------------------------------------------------------------------------
LRESULT CRemMFCDlg::OnMmttyMessage(WPARAM wParam, LPARAM lParam)
{
	switch(wParam){
		case TXM_HANDLE:
			m_hMMWnd = (HWND)lParam;
			PostMmttyMessage(RXM_HANDLE, (DWORD)m_hWnd);
			break;
		case TXM_REQHANDLE:
			PostMmttyMessage(RXM_HANDLE, (DWORD)m_hWnd);
			break;
		case TXM_START:
			ASSERT(m_hMMWnd != HWND_BROADCAST);
			m_bConnected = TRUE;
			DispStatus();
			break;
		case TXM_PTTEVENT:
			m_ptt = lParam;
			m_DlgTX.SetState(lParam);
			m_DlgTX.SetWindowText("TX(F9)");
			if( !m_ptt ) m_DlgTXW.Clear();
			PutPttStatus();
			break;
		case TXM_CHAR:
			m_DlgConsole.PutChar(char(lParam), m_DlgTX.GetState());
			break;
		case TXM_MARK:
			m_NMmtty.m_markfreq = lParam;
			break;
		case TXM_SPACE:
			m_NMmtty.m_spacefreq = lParam;
			UpdateSpectramWidth();
			UpdateControlButton();
			break;
		case TXM_SWITCH:
			m_NMmtty.m_codeswitch = lParam;
			UpdateControlButton();
			break;
		case TXM_VIEW:
			m_NMmtty.m_codeview = lParam;
			{
				// XYXR[vON/OFFMMTTYƍ킹܂B
				BOOL bShowXyScope = (m_NMmtty.m_codeview & 0x00001000) != 0;
				if( bShowXyScope != m_bShowXyScope ){
					m_bShowXyScope = bShowXyScope;
					UpdateItemSize();
				}
			}
			break;
		case TXM_LEVEL:
			m_NMmtty.m_siglevel = LOWORD(lParam);
			m_NMmtty.m_sqlevel = HIWORD(lParam);
			OnDrawLevel();
			break;
		case TXM_NOTCH:
			m_NMmtty.m_notch1 = LOWORD(lParam);
			m_NMmtty.m_notch2 = HIWORD(lParam);
			break;
	}
	return FALSE;
}
//---------------------------------------------------------------------------
void CRemMFCDlg::UpdateDlgButton(void)
{
	m_DlgTX.EnableWindow(!m_Wait);
	m_DlgM1.EnableWindow(!m_Wait);
	m_DlgM2.EnableWindow(!m_Wait);
	m_DlgM3.EnableWindow(!m_Wait);
	m_DlgM4.EnableWindow(!m_Wait);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::UpdateControlButton(void)
{
	// TXM_SWITCHŒʒmXCb`Ń{^̏ԂXV܂B
	m_DlgAFC.SetState(m_NMmtty.m_codeswitch & swAFC);
	m_DlgNET.SetState(m_NMmtty.m_codeswitch & swNET);
	m_DlgREV.SetState(m_NMmtty.m_codeswitch & swREV);
	m_DlgBPF.SetState(m_NMmtty.m_codeswitch & swBPF);
	m_DlgATC.SetState(m_NMmtty.m_codeswitch & swATC);
	m_DlgSQ.SetState(m_NMmtty.m_codeswitch & swSQ);
	m_DlgLMS.SetState(m_NMmtty.m_codeswitch & swLMS);
	m_DlgUOS.SetState(m_NMmtty.m_codeswitch & swUOS);
	switch(m_NMmtty.m_codeswitch & 3){
	case 0:
		m_DlgTYPE.SetWindowText("IIR");
		break;
	case 1:
		m_DlgTYPE.SetWindowText("FIR");
		break;
	case 2:
		m_DlgTYPE.SetWindowText("PLL");
		break;
	default:
		m_DlgTYPE.SetWindowText("???");
		break;
	}
	m_DlgLMS.SetWindowText(m_NMmtty.m_codeswitch & swNOT ? "NOT":"LMS");

	LONG sf = m_NMmtty.m_spacefreq - m_NMmtty.m_markfreq;
	if( m_Shift != sf ){
		m_Shift = sf;
		char bf[64];
		wsprintf(bf, "%d", sf);
		m_DlgShift.SetWindowText(bf);
	}
}
//---------------------------------------------------------------------------
void CRemMFCDlg::UpdateSpectramWidth(void)
{
	if( m_bAutoSpectram ){
		if( m_bCaptureSpectram ) return;
		// XyNg̕\͈͂Ō肵܂B
		LONG fc = (m_NMmtty.m_markfreq + m_NMmtty.m_spacefreq) / 2;
		LONG fw = m_NMmtty.m_spacefreq - m_NMmtty.m_markfreq;
		if( (fw >= 500) || (m_rcSpectram.right > 350) ){		// 2500Hz
			m_SpecWidth = 2500;
			m_SpecBase = 250;
		}
		else if( (fw >= 400) || (m_rcSpectram.right > 300) ){	// 2000Hz
			m_SpecWidth = 2000;
			m_SpecBase = fc - 1000;
		}
		else if( (fw >= 300) || (m_rcSpectram.right > 250) ){	// 1500Hz
			m_SpecWidth = 1500;
			m_SpecBase = fc - 750;
		}
		else {					// 1000Hz
			m_SpecWidth = 1000;
			m_SpecBase = fc - 500;
		}
		if( m_SpecBase < 0 ) m_SpecBase = 0;
	}
	if( !m_bConnected ) OnDrawSpectram(NULL);
}
//---------------------------------------------------------------------------
// Rg[̃TCY𒲐܂B
void CRemMFCDlg::UpdateItemSize(void)
{
	RECT rcStatus;
	m_DlgNGroup.GetClientRect(&rcStatus);
	rcStatus.right = m_rcClient.right;
	m_DlgNGroup.MoveWindow(&rcStatus);
	RECT rc = m_rcClient;
	rc.top = rcStatus.bottom + 2;
	rc.bottom = m_Splitter.GetSplitter();
	m_DlgConsole.MoveWindow(&rc);
	rc.top = rc.bottom + 1;
	rc.bottom = m_rcClient.bottom;
	m_DlgTXW.MoveWindow(&rc);

	UpdateSpectramSize();
}
//---------------------------------------------------------------------------
// m_DlgSpectramRg[̕𒲐Arbg}bvč\z܂B
void CRemMFCDlg::UpdateSpectramSize(void)
{
	int right = m_rcClient.right - 2;
	RECT rcXY;
	m_DlgXY.GetWindowRect(&rcXY);
	ScreenToClient(&rcXY);
	if( (rcXY.right != right) || (m_DlgXY.IsWindowVisible() != m_bShowXyScope) ){
		RECT rcSpectram;
		m_DlgSpectram.GetWindowRect(&rcSpectram);
		ScreenToClient(&rcSpectram);
		int xoff = right - rcXY.right;
		rcXY.left += xoff;
		rcXY.right += xoff;
		rcSpectram.right = m_bShowXyScope ? rcXY.left : rcXY.right;
		if( (rcSpectram.left + 100) < rcSpectram.right ){
			m_DlgXY.MoveWindow(&rcXY);
			m_DlgSpectram.MoveWindow(&rcSpectram);
			m_DlgSpectram.InitialUpdate(this);

			m_bmpSpectram.DeleteObject();
			m_rcSpectram.right = m_DlgSpectram.GetXW();
			m_rcSpectram.bottom = m_DlgSpectram.GetYW();
			CDC *pDC = GetDC();
			m_bmpSpectram.CreateCompatibleBitmap(pDC, m_rcSpectram.right, m_rcSpectram.bottom);
			ReleaseDC(pDC);
			m_DlgSpectram.SetBitmap(m_bmpSpectram, &m_rcSpectram, RGB(0,0,0));
			UpdateSpectramWidth();
		}
		m_DlgXY.ShowWindow(m_bShowXyScope ? SW_SHOW : SW_HIDE);
	}
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnDrawLevel(void)
{
	DrawLevel();
	if( m_pCom ){
		// M̎AőMEChE̕MMTTYɑ܂B
		if( m_DlgTX.GetState() ){
			int len = m_pCom->TxBuffCount;
			while( m_DlgTXW.GetLen() && (len < 2) ){
				// MMTTYRTTYMobt@͂ɂȂ܂B
				// MEChE當oMMTTYɑ܂B
				BYTE c = m_DlgTXW.GetChar();
				if( c < 0x80 ){
					PostMmttyMessage(RXM_CHAR, c);
					if( c == '\r' ) PostMmttyMessage(RXM_CHAR, '\n');
					len++;
				}
				else {
					break;
				}
			}
		}

		if( m_bHighXyQuality && !m_pIX ){
			// XYf[^̃I[o[TvÔ߂ɃC^[|[[^쐬܂B
			m_pIX = new CINTPXY2(m_pCom->smpDemFreq);
			m_pIY = new CINTPXY2(m_pCom->smpDemFreq);
		}

		if( m_pCom->flagFFT ) OnDrawSpectram(m_pCom);
		if( m_pCom->flagXY ) OnDrawXY(m_pCom);
	}
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnDrawSpectram(COMARRAY *pCom)
{
	LONG fft[2048];
	if( pCom ){
		memcpy(fft, pCom->arrayFFT, sizeof(fft));
		pCom->flagFFT = FALSE;
	}

	CDC dc;
	dc.CreateCompatibleDC(NULL);
	CBitmap *pOldBmp = dc.SelectObject(&m_bmpSpectram);
	dc.FillSolidRect(&m_rcSpectram, RGB(0,0,0));

	// 300Hz, 2700HzQ[W`悵܂B
	CPen penlimit(PS_DOT, 0, RGB(128,128,128));
	CPenSelect pslimit(&dc, &penlimit);
	int x = (300 - m_SpecBase) * m_rcSpectram.right / m_SpecWidth;
	dc.MoveTo(x, 0);
	dc.LineTo(x, m_rcSpectram.bottom);
	x = (2700 - m_SpecBase) * m_rcSpectram.right / m_SpecWidth;
	dc.MoveTo(x, 0);
	dc.LineTo(x, m_rcSpectram.bottom);
	pslimit.Release();
	penlimit.DeleteObject();

	// }[N/Xy[XgQ[W`悵܂B
	CPen penmarker(PS_DOT, 0, RGB(255,255,0));
	CPenSelect ps(&dc, &penmarker);
	x = (m_NMmtty.m_markfreq - m_SpecBase) * m_rcSpectram.right / m_SpecWidth;
	dc.MoveTo(x, 0);
	dc.LineTo(x, m_rcSpectram.bottom);
	x = (m_NMmtty.m_spacefreq - m_SpecBase) * m_rcSpectram.right / m_SpecWidth;
	dc.MoveTo(x, 0);
	dc.LineTo(x, m_rcSpectram.bottom);
	ps.Release();
	penmarker.DeleteObject();

	if( pCom ){
		const LONG *pFFT = fft;
		LONG sampFFT = pCom->smpFreq;
		LONG sizeFFT = (sampFFT < 10000) ? 1024 : 2048;
		// XyNg`悵܂B
		CPen pen(PS_SOLID, 0, RGB(255,255,255));
		CPenSelect ps(&dc, &pen);
		int off = m_SpecBase * sizeFFT / sampFFT;
		double k = double(m_SpecWidth) * double(sizeFFT)/(double(m_rcSpectram.right) * double(sampFFT));
		int y;
		int max = 256;
		for( x = 0; x < m_rcSpectram.right; x++ ){
			y = pFFT[int(x * k) + off];
			if( y < 0 ) y = 0;
			if( y > max ) y = max;
			y = m_rcSpectram.bottom - (y * m_rcSpectram.bottom / max);
			if( x ){
				dc.LineTo(x, y);
			}
			else {
				dc.MoveTo(x, y);
			}
		}
		ps.Release();
		pen.DeleteObject();
	}
	if( (m_NMmtty.m_codeswitch & (swLMS|swNOT)) == (swLMS|swNOT) ){
		// mb`tB^̃}[J[`悵܂B
		x = (m_NMmtty.m_notch1 - m_SpecBase) * m_rcSpectram.right / m_SpecWidth;
		POINT	ary[3];
		ary[0].x = x; ary[0].y = m_rcSpectram.bottom - 1;
		ary[1].x = x - 3; ary[1].y = m_rcSpectram.bottom - 6;
		ary[2].x = x + 3; ary[2].y = m_rcSpectram.bottom - 6;
		CPen pen(PS_SOLID, 0, RGB(255,255,0));
		CPenSelect ps(&dc, &pen);
		CBrush brushR(RGB(255,0,0));
		CBrushSelect bs(&dc, &brushR);
		dc.Polygon(ary, 3);
		bs.Release();
		brushR.DeleteObject();
		if( (m_NMmtty.m_codeswitch & swTWO) && m_NMmtty.m_notch2 ){
			x = (m_NMmtty.m_notch2 - m_SpecBase) * m_rcSpectram.right / m_SpecWidth;
			ary[0].x = x; ary[1].x = x - 3; ary[2].x = x + 3;
			CBrush brushB(RGB(0,0,255));
			CBrushSelect bs(&dc, &brushB);
			dc.Polygon(ary, 3);
			bs.Release();
			brushB.DeleteObject();
		}
		ps.Release();
		pen.DeleteObject();
	}
	// }[NgƃVtg̐l`悵܂B
	char bf[32];
	wsprintf(bf, "%d", m_NMmtty.m_markfreq);
	CFontSelect fs(&dc, GetFont());
	CSize funit = dc.GetTextExtent(bf);
	dc.SetTextColor(RGB(255,255,0));
	int bm = dc.SetBkMode(TRANSPARENT);
	dc.TextOut(4, 1, bf);
	wsprintf(bf, "%d", m_NMmtty.m_spacefreq - m_NMmtty.m_markfreq);
	dc.TextOut(4, funit.cy + 1, bf);
	fs.Release();
	dc.SetBkMode(bm);

	dc.SelectObject(pOldBmp);
	dc.DeleteDC();
	m_DlgSpectram.Draw(TRUE);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnDrawXY(COMARRAY *pCom)
{
	LONG X[512], Y[512];
	if( pCom ){
		memcpy(X, pCom->arrayX, sizeof(X));
		memcpy(Y, pCom->arrayY, sizeof(Y));
		pCom->flagXY = FALSE;
	}

	LPLONG bx = X;
	LPLONG by = Y;
	int count = 512;
	int i;
	LPLONG px, py;

	LONG IX[1024], IY[1024];
	LONG max = 0;
	if( pCom ){
		if( m_bHighXyQuality && m_pIX ){
			// f[^I[o[TvO܂B
			px = bx; py = by;
			LPLONG ptx = IX;
			LPLONG pty = IY;
			m_pIX->Clear(); m_pIY->Clear();
			for( i = 0; i < count; i++ ){
				m_pIX->Do(ptx, *px++); m_pIY->Do(pty, *py++);
			}
			count = 1024;
			bx = IX; by = IY;
		}

		px = bx; py = by;
		for( i = 0; i < count; i++, px++, py++ ){
			if( max < *px ) max = *px;
			if( max < *py ) max = *py;
		}
		if( max < 16384 ) max = 16384;
		max = max * 16 / 7;
	}

	CDC dc;
	dc.CreateCompatibleDC(NULL);
	CBitmap *pOldBmp = dc.SelectObject(&m_bmpXY);
	dc.FillSolidRect(&m_rcXY, RGB(0,0,0));
	if( pCom ){
		int x, y;
		int XC = m_rcXY.right / 2;
		int YC = m_rcXY.bottom / 2;
		CPen pen(PS_SOLID, 0, RGB(0,255,0));
		CPenSelect ps(&dc, &pen);
		px = bx; py = by;
		for( i = 0; i < count; i++, px++, py++ ){
			x = XC + (*px * m_rcXY.right)/ max;
			y = YC + (*py * m_rcXY.bottom)/ max;
			dc.MoveTo(x, y); dc.LineTo(x+1, y);
		}
		ps.Release();
		pen.DeleteObject();
	}
	dc.SelectObject(pOldBmp);
	dc.DeleteDC();
	m_DlgXY.Draw(TRUE);
}
//---------------------------------------------------------------------------
// xCfBP[^ŕ\܂B
void CRemMFCDlg::DrawLevel(void)
{
	LONG sig = m_NMmtty.m_siglevel;
	LONG sq = m_NMmtty.m_sqlevel;
	if( !(m_NMmtty.m_codeswitch & swSQ) ) sq = -1;
	if( sig > 1024 ) sig = 1024;
	CDC dc;
	dc.CreateCompatibleDC(NULL);
	CBitmap *pOldBmp = dc.SelectObject(&m_bmpLevel);
	dc.FillSolidRect(&m_rcSpectram, RGB(0,0,0));

	COLORREF col = (sig < sq) ? RGB(128,128,128) : RGB(0,255,0);
	RECT rc = m_rcLevel;
	rc.top = rc.bottom - (sig * rc.bottom / 1024);
	dc.FillSolidRect(&rc, col);

	rc.top = rc.bottom - (sq * rc.bottom / 1024);
	if( rc.top < rc.bottom ){
		CPen penmarker(PS_SOLID, 0, RGB(255,255,0));
		CPenSelect ps(&dc, &penmarker);
		dc.MoveTo(0, rc.top);
		dc.LineTo(m_rcLevel.right, rc.top);
		ps.Release(); penmarker.DeleteObject();
	}

	dc.SelectObject(pOldBmp);
	dc.DeleteDC();
	m_DlgLevel.Draw(TRUE);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::DeleteIXY(void)
{
	// C^[|[[^폜܂B
	if( m_pIX ){
		delete m_pIX;
		delete m_pIY;
		m_pIX = m_pIY = NULL;
	}
}
//---------------------------------------------------------------------------
BOOL CRemMFCDlg::ProcessMessages(void)
{
	// EGCg̃bZ[W邽߂ɗՎ̃bZ[W|v
	// 𓮂܂B
	MSG msg;
	while( ::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE) ){
		if( msg.message == WM_COMMAND ){
			UINT id = LOWORD(msg.wParam);
			if( (id == IDCANCEL) || (id == ID_APP_EXIT) ){
				// AvP[VI邽߂Ƀ[_[vɖ߂܂B
				// ŃbZ[WĂ͂܂B
				return FALSE;
			}
		}
		if( !GetApp()->PumpMessage() ) return FALSE;
	}
	return TRUE;
}
//---------------------------------------------------------------------------
void CRemMFCDlg::PutPttStatus(void)
{
	SYSTEMTIME time;
	::GetLocalTime(&time);
	char bbf[128];
	wsprintf(bbf, "%u/%u/%u %u:%02u:%02u", time.wYear, time.wMonth, time.wDay, time.wHour, time.wMinute, time.wSecond);
	char bf[128];
	if( m_DlgTX.GetState() ){
		wsprintf(bf, "[TX %s]", bbf);
	}
	else {
		wsprintf(bf, "[RX %s]", bbf);
	}
	m_DlgConsole.PutStatus(bf, 2);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::DispWaitStatus(void)
{
	if( !m_pCom ) return;
	char bf[256];
	if( m_pCom->TxBuffCount < 1024 ){
		wsprintf(bf, "Wait till PostMessage is completed");
	}
	else {
		wsprintf(bf, "Wait for the transmission flows (%d)", m_pCom->TxBuffCount);
	}
	m_DlgNStatus.SetWindowText(bf, RGB(255,255,0));
}
//---------------------------------------------------------------------------
BOOL CRemMFCDlg::WaitBusy(void)
{
	if( !m_pCom ) return FALSE;
	// RTTY̓`x̓bZ[W̓`xx̂ŁAt@CM̂悤
	// ʂ̃f[^AđMꍇǍh߂ɂ
	// MMTTY̑Mobt@READYɂȂ܂ő҂Kv܂BOnFileSend()
	// QƂĉB

	int r = TRUE;
	if( !ProcessMessages() ) return FALSE;
	// MMTTY̑Mobt@̃TCY2048ł
	if( m_pCom->TxBuffCount >= 1024 ){
		m_Cancel = FALSE;
		m_Wait++;
		UpdateDlgButton();
		DispWaitStatus();
		while((volatile LONG)m_pCom->TxBuffCount >= 1024){
			::WaitMessage();
			DispWaitStatus();
			if( !ProcessMessages() ) return FALSE;
			if( m_Cancel ){
				r = FALSE;
				break;
			}
		}
		m_Wait--;
		if( !m_Wait ){
			DispStatus();
			UpdateDlgButton();
		}
	}
	return r;
}
//---------------------------------------------------------------------------
void CRemMFCDlg::PostMmttyMessage(DWORD wParam, DWORD lParam)
{
	// MMTTYɃbZ[W𑗂܂B
	::PostMessage(m_hMMWnd, gMsgMmtty, wParam, lParam);
}
//---------------------------------------------------------------------------
// MMTTYɃXCb`𑗂܂B
void CRemMFCDlg::SendSwitch(DWORD codeswitch)
{
	m_NMmtty.m_codeswitch = codeswitch;
	PostMmttyMessage(RXM_SETSWITCH, codeswitch);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::HookKeyMessage(BOOL bHook)
{
	if( bHook ){
		m_DlgTXW.SetCursor(csBLINK);
		m_DlgConsole.SetCursor(csON);
		GetApp()->HookKeyMessage(TRUE);
	}
	else {
		m_DlgTXW.SetCursor(csOFF);
		m_DlgConsole.SetCursor(csOFF);
		GetApp()->HookKeyMessage(FALSE);
	}
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnKeyChar(WPARAM wParam, LPARAM lParam)
{
	BYTE c = wParam;
	// MEChEɕ݂܂B
	c = toupper(c);
	m_DlgTXW.PutChar(c, 1);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnFuncKeyChar(WPARAM wParam, LPARAM lParam)
{
	switch(wParam){
		case VK_ESCAPE:
			OnBtxoff();
			break;
		case VK_F9:
			if( m_DlgTX.IsWindowEnabled() ){
				m_DlgTX.SetState(!m_DlgTX.GetState());
				OnBtx();
			}
			break;
		default:
			break;
	}
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if( !m_rcClient.right ) return;
	if( (cx <= 0) || (cy <= 0) ) return;
	m_rcClient.right = cx;
	m_rcClient.bottom = cy;
	m_Splitter.SetRange(m_rcGroup.bottom, cy);
	UpdateItemSize();
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
{
	pPopupMenu->EnableMenuItem(ID_FILE_SEND, (m_Wait || !m_bConnected) ? MF_DISABLED|MF_GRAYED : MF_ENABLED );
	UINT uID = m_bAutoSpectram ? ID_VIEW_SPECTRAM_AUTO : ID_VIEW_SPECTRAM_WIDE;
	pPopupMenu->CheckMenuRadioItem(ID_VIEW_SPECTRAM_AUTO, ID_VIEW_SPECTRAM_WIDE, uID, MF_BYCOMMAND);
	pPopupMenu->CheckMenuItem(ID_VIEW_XYSCOPE, m_bShowXyScope ? MF_CHECKED : MF_UNCHECKED );
	pPopupMenu->CheckMenuItem(ID_VIEW_HIGHXYQUALITY, m_bHighXyQuality ? MF_CHECKED : MF_UNCHECKED );
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu)
{
	HookKeyMessage(nFlags == 0x0000ffff);
	CDialog::OnMenuSelect(nItemID, nFlags, hSysMenu);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnBtx() 
{
	m_DlgNStatus.SetFocus();
	BOOL ptt = m_DlgTX.GetState();
	PostMmttyMessage(RXM_PTT, ptt ? 2 : 1);
	m_DlgTX.SetWindowText("REQ");
	m_DlgTX.SetState(m_ptt);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnBtxoff() 
{
	m_DlgNStatus.SetFocus();
	PostMmttyMessage(RXM_PTT, 0);
	if( m_DlgTX.GetState() ){
		m_DlgTX.SetWindowText("REQ");
	}
	m_Cancel = TRUE;
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnFileSend() 
{
	if( !m_pCom ) return;

	CFileDialog dlg( TRUE, "txt", NULL, OFN_HIDEREADONLY, "text files(*.txt)|*.txt||", NULL );
	dlg.m_ofn.lpstrTitle = "Send file";
	if( dlg.DoModal() == IDOK ){
		FILE *fp = fopen(dlg.GetPathName(), "rb");
		char bf[128];
		if( fp != NULL ){
			if( !m_DlgTX.GetState() ) PostMmttyMessage(RXM_PTT, 2);
			// MMTTY̑Mobt@2048oCgȂ̂ŁAʂ̃f[^
			// Mꍇ́A𒴂Ȃ悤ɑȂ΂Ȃ܂B
			// WaitBusy()QƂĉB
			m_Cancel = FALSE;
			while(!feof(fp) && !m_Cancel){
				int len = fread(bf, 1, sizeof(bf), fp);
				if( len <= 0 ) break;
				if( !WaitBusy() ) break;
				LONG txlen = m_pCom->TxBuffCount;
				SendString(bf, len);
				if( len >= sizeof(bf) ){
					// PostMessage͂ɂ͏Ȃ̂ŁAMMTTY
					// bZ[W܂łő҂܂BMMTTY
					// bZ[WƁASendString()ő
					// ɂTxBuffCount܂B
					DispWaitStatus();
					while( txlen >= (volatile LONG)m_pCom->TxBuffCount ){
						::WaitMessage();
						if( !ProcessMessages() ) break;
						if( m_Cancel ) break;
					}
				}
			}
			fclose(fp);
			DispStatus();
		}
	}
}
//---------------------------------------------------------------------------
// CImageStaticŃ}EXꂽ̏s܂B
void CRemMFCDlg::OnImageMouse(CImageStatic *pStatic, UINT code, LPRECT prc)
{
	ASSERT(pStatic);
	ASSERT(pStatic->IsKindOf(RUNTIME_CLASS(CImageStatic)));

	if( pStatic == &m_DlgSpectram ){
		// XyNgŃ}EXꂽĂ΂܂B
		ASSERT(prc->right);
		LONG fq = m_SpecBase + prc->left * m_SpecWidth / prc->right;
		if( fq < 300 ) fq = 300;
		if( fq > 2700 ) fq = 2700;
		if( code < IS_RDOWN ){			// V}[Ngw肳܂B
			if( code == IS_LDOWN ) m_bCaptureSpectram = TRUE;
			if( code == IS_LUP ) m_bCaptureSpectram = FALSE;
			LONG shift = m_NMmtty.m_spacefreq - m_NMmtty.m_markfreq;
			m_NMmtty.m_markfreq = fq;
			m_NMmtty.m_spacefreq = m_NMmtty.m_markfreq + shift;
			if( m_NMmtty.m_spacefreq > 2700 ){
				// ōg2700Hz𒴂Ȃ悤ɂ܂B
				fq = m_NMmtty.m_spacefreq - 2700;
				m_NMmtty.m_markfreq -= fq;
				m_NMmtty.m_spacefreq -= fq;
			}
			// MMTTYMark/Spacegݒ肵܂B
			PostMmttyMessage(RXM_SETMARK, m_NMmtty.m_markfreq);
			PostMmttyMessage(RXM_SETSPACE, m_NMmtty.m_spacefreq);
			UpdateSpectramWidth();
		}
		else {							// Vmb`gw肳܂B
			if( (m_NMmtty.m_codeswitch & swTWO) && ((code == IS_RMOVE)||(code == IS_RUP)) ) return;
			// mb`g𑗂܂B
			PostMmttyMessage(RXM_NOTCH, fq);
			// mb`tB^OFF̎AONɂ܂B
			if( (m_NMmtty.m_codeswitch & (swLMS|swNOT)) != (swLMS|swNOT) ){
				SendSwitch(m_NMmtty.m_codeswitch | swLMS|swNOT);
			}
		}
	}
	else if( pStatic == &m_DlgLevel ){
		// xCfBP[^Ń}EXꂽĂ΂܂B
		if( code < IS_RDOWN ){		// VXP`xw肳܂
			ASSERT(prc->bottom);
			m_NMmtty.m_sqlevel = (prc->bottom - prc->top) * 1024 / prc->bottom;
			PostMmttyMessage(RXM_SETSQLVL, m_NMmtty.m_sqlevel);
			// XP`OFF̎AONɂ܂B
			if( !(m_NMmtty.m_codeswitch & swSQ) ) SendSwitch(m_NMmtty.m_codeswitch | swSQ);
		}
		else if( code == IS_RDOWN ){// XP`OFFɂ܂
			if( m_NMmtty.m_codeswitch & swSQ ) SendSwitch(m_NMmtty.m_codeswitch & ~swSQ);
		}
	}
}
//---------------------------------------------------------------------------
// CToggleButtonŉE}EX{^NbNꂽAĂ΂܂B
void CRemMFCDlg::OnToggleRClick(CToggleButton *pButton)
{
	ASSERT(pButton);
	ASSERT(pButton->IsKindOf(RUNTIME_CLASS(CToggleButton)));

	CString *pStr = NULL;
	if( pButton == &m_DlgM1 ){
		pStr = &m_Msg[0];
	}
	else if(pButton == &m_DlgM2 ){
		pStr = &m_Msg[1];
	}
	else if(pButton == &m_DlgM3 ){
		pStr = &m_Msg[2];
	}
	else if(pButton == &m_DlgM4 ){
		pStr = &m_Msg[3];
	}
	else if(pButton == &m_DlgLMS ){
		// mb`tB^LMS؂ւ܂B
		if( m_NMmtty.m_codeswitch & swNOT ){
			m_NMmtty.m_codeswitch &= ~swNOT;
		}
		else {
			m_NMmtty.m_codeswitch |= swNOT;
		}
		SendSwitch(m_NMmtty.m_codeswitch);
	}
	if( pStr ){
		CEditDialog dlg(this);
		dlg.m_DlgEdit = *pStr;
		if( dlg.DoModal() == IDOK ){
			*pStr = dlg.m_DlgEdit;
		}
	}
}
//---------------------------------------------------------------------------
BOOL CRemMFCDlg::SendString(LPCSTR pStr)
{
	while(*pStr){
		if( !WaitBusy() ) return FALSE;
		PostMmttyMessage(RXM_CHAR, *pStr++);
	}
	return TRUE;
}
//---------------------------------------------------------------------------
void CRemMFCDlg::SendString(LPCSTR pStr, int size)
{
	for(int i = 0; *pStr && (i < size); i++){
		PostMmttyMessage(RXM_CHAR, *pStr++);
	}
}
//---------------------------------------------------------------------------
void CRemMFCDlg::SendMsgButton(LPCSTR pStr)
{
	if( m_DlgTX.GetState() ){
		SendString(pStr);
	}
	else {
		PostMmttyMessage(RXM_PTT, 2);
		SendString(pStr);
	}
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnBm1() 
{
	SendMsgButton(m_Msg[0]);
}
void CRemMFCDlg::OnBm2() 
{
	SendMsgButton(m_Msg[1]);
}
void CRemMFCDlg::OnBm3() 
{
	SendMsgButton(m_Msg[2]);
}
void CRemMFCDlg::OnBm4() 
{
	SendMsgButton(m_Msg[3]);
}
//---------------------------------------------------------------------------
void CRemMFCDlg::OnAfc() 
{
	if( m_DlgAFC.GetState() ){
		m_NMmtty.m_codeswitch |= swAFC;
	}
	else {
		m_NMmtty.m_codeswitch &= ~swAFC;
	}
	SendSwitch(m_NMmtty.m_codeswitch);
}
void CRemMFCDlg::OnNet() 
{
	if( m_DlgNET.GetState() ){
		m_NMmtty.m_codeswitch |= swNET;
	}
	else {
		m_NMmtty.m_codeswitch &= ~swNET;
	}
	SendSwitch(m_NMmtty.m_codeswitch);
}
void CRemMFCDlg::OnHam() 
{
	PostMmttyMessage(RXM_SETHAM, 0);
}
void CRemMFCDlg::OnAtc() 
{
	if( m_DlgATC.GetState() ){
		m_NMmtty.m_codeswitch |= swATC;
	}
	else {
		m_NMmtty.m_codeswitch &= ~swATC;
	}
	SendSwitch(m_NMmtty.m_codeswitch);
}
void CRemMFCDlg::OnBpf() 
{
	if( m_DlgBPF.GetState() ){
		m_NMmtty.m_codeswitch |= swBPF;
	}
	else {
		m_NMmtty.m_codeswitch &= ~swBPF;
	}
	SendSwitch(m_NMmtty.m_codeswitch);
}
void CRemMFCDlg::OnLms() 
{
	if( m_DlgLMS.GetState() ){
		m_NMmtty.m_codeswitch |= swLMS;
	}
	else {
		m_NMmtty.m_codeswitch &= ~swLMS;
	}
	SendSwitch(m_NMmtty.m_codeswitch);
}
void CRemMFCDlg::OnRev() 
{
	if( m_DlgREV.GetState() ){
		m_NMmtty.m_codeswitch |= swREV;
	}
	else {
		m_NMmtty.m_codeswitch &= ~swREV;
	}
	SendSwitch(m_NMmtty.m_codeswitch);
}
void CRemMFCDlg::OnSq() 
{
	if( m_DlgSQ.GetState() ){
		m_NMmtty.m_codeswitch |= swSQ;
	}
	else {
		m_NMmtty.m_codeswitch &= ~swSQ;
	}
	SendSwitch(m_NMmtty.m_codeswitch);
}
void CRemMFCDlg::OnType() 
{
	int typ = m_NMmtty.m_codeswitch & 3;
	typ++;
	if( typ >= 3 ) typ = 0;
	m_NMmtty.m_codeswitch &= ~3;
	m_NMmtty.m_codeswitch |= typ;
	SendSwitch(m_NMmtty.m_codeswitch);
}
void CRemMFCDlg::OnUos() 
{
	if( m_DlgUOS.GetState() ){
		m_NMmtty.m_codeswitch |= swUOS;
	}
	else {
		m_NMmtty.m_codeswitch &= ~swUOS;
	}
	SendSwitch(m_NMmtty.m_codeswitch);
}

void CRemMFCDlg::OnViewSpectramAuto() 
{
	m_bAutoSpectram = TRUE;
	UpdateSpectramWidth();
}

void CRemMFCDlg::OnViewSpectramWide() 
{
	m_bAutoSpectram = FALSE;
	m_SpecBase = 250;
	m_SpecWidth = 2500;
	UpdateSpectramWidth();
}

void CRemMFCDlg::OnSelchangeShift() 
{
	int n = m_DlgShift.GetCurSel();
	CString cs;
	m_DlgShift.GetLBText(n, cs);
	m_Shift = atoi(cs);
	m_NMmtty.m_spacefreq = m_NMmtty.m_markfreq + m_Shift;
	if( m_NMmtty.m_spacefreq > 2700 ){
		// ōg2700Hz𒴂Ȃ悤ɂ܂B
		LONG fq = m_NMmtty.m_spacefreq - 2700;
		m_NMmtty.m_markfreq -= fq;
		m_NMmtty.m_spacefreq -= fq;
	}
	// MMTTYMark/Spacegݒ肵܂B
	PostMmttyMessage(RXM_SETMARK, m_NMmtty.m_markfreq);
	PostMmttyMessage(RXM_SETSPACE, m_NMmtty.m_spacefreq);
	m_DlgNStatus.SetFocus();
}

void CRemMFCDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if( m_Splitter.OnMouseMove(point) ) UpdateItemSize();
	CDialog::OnMouseMove(nFlags, point);
}

void CRemMFCDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_Splitter.OnLButtonDown(point);
	CDialog::OnLButtonDown(nFlags, point);
}

void CRemMFCDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_Splitter.OnLButtonUp(point);
	CDialog::OnLButtonUp(nFlags, point);
}
void CRemMFCDlg::OnActivate( UINT nState, CWnd* pWndOther, BOOL bMinimized )
{
	HookKeyMessage(nState != WA_INACTIVE);
	CDialog::OnActivate(nState, pWndOther, bMinimized);
}
void CRemMFCDlg::OnViewXyscope() 
{
	m_bShowXyScope = !m_bShowXyScope;
	if( m_bShowXyScope ){
		m_NMmtty.m_codeview |= 0x00001000;
	}
	else {
		m_NMmtty.m_codeview &= ~0x00001000;
	}
	PostMmttyMessage(RXM_SETVIEW, m_NMmtty.m_codeview);
	UpdateItemSize();
}
void CRemMFCDlg::OnViewHighxyquality() 
{
	m_bHighXyQuality = !m_bHighXyQuality;
}

void CRemMFCDlg::OnOptionSetup() 
{
	PostMmttyMessage(RXM_SHOWSETUP, FALSE);
}

void CRemMFCDlg::OnOptionReconnect() 
{
	OpenMmtty();
}
void CRemMFCDlg::OnOptionInvoke() 
{
	CInputDialog dlg;

	dlg.m_Caption = "Enter invoking command";
	dlg.m_Edit = m_InvokeCommand;
	if( dlg.DoModal() == IDOK ){
		if( dlg.m_Edit.IsEmpty() ) dlg.m_Edit = "MMTTY -m";
		if( dlg.m_Edit != m_InvokeCommand ){
			m_InvokeCommand = dlg.m_Edit;
			OpenMmtty();
		}
	}
}
