// RemMFCDlg.h : wb_[ t@C
//

#if !defined(AFX_RemMFCDlg_H__842C61C4_80A2_412E_B5D8_286FEC3FF2DE__INCLUDED_)
#define AFX_RemMFCDlg_H__842C61C4_80A2_412E_B5D8_286FEC3FF2DE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ColorStatic.h"
#include "DumpStatic.h"
#include "IStatic.h"
#include "TButton.h"
#include "Filter.h"
/////////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------
enum {
	RXM_HANDLE=0x0000,	// APP -> MMTTY
	RXM_REQHANDLE,
	RXM_EXIT,
	RXM_PTT,
	RXM_CHAR,

	RXM_WINPOS,
	RXM_WIDTH,
	RXM_REQPARA,
	RXM_SETBAUD,
	RXM_SETMARK,

	RXM_SETSPACE,
	RXM_SETSWITCH,
	RXM_SETHAM,
	RXM_SHOWSETUP,
	RXM_SETVIEW,

	RXM_SETSQLVL,
	RXM_SHOW,
	RXM_SETFIG,
	RXM_SETRESO,
	RXM_SETLPF,

	RXM_SETTXDELAY,
	RXM_UPDATECOM,
	RXM_SUSPEND,
	RXM_NOTCH,
	RXM_PROFILE,

    RXM_TIMER,
//    RXM_ENBFOCUS,	// added on Ver1.63A
//    RXM_SETDEFFREQ,	// added on Ver1.63B
//    RXM_SETLENGTH,	// added on Ver1.63B
//--------------------------------------
	TXM_HANDLE=0x8000,	// MMTTY -> APP
	TXM_REQHANDLE,
	TXM_START,
	TXM_CHAR,
	TXM_PTTEVENT,

	TXM_HEIGHT,
	TXM_BAUD,
	TXM_MARK,
	TXM_SPACE,
	TXM_SWITCH,

	TXM_VIEW,
	TXM_LEVEL,
	TXM_FIGEVENT,
	TXM_RESO,
	TXM_LPF,

	TXM_THREAD,
	TXM_PROFILE,
    TXM_NOTCH,
    TXM_DEFSHIFT,
//    TXM_RADIOFREQ,	// added on Ver1.63
};
#pragma pack(push, 1)
typedef struct {
	LONG	smpFreq;	// MMTTY->APP
	CHAR	title[128];	// APP->MMTTY
	CHAR	comName[16];// APP->MMTTY
	LONG	smpFFT;		// APP->MMTTY 0-11025, 1-8000

	LONG	flagFFT;
	LONG	arrayFFT[2048];
	LONG	flagXY;
	LONG	arrayX[512];
	LONG	arrayY[512];

	CHAR	verMMTTY[16];
	CHAR	comRadio[16];
	LONG	LostSound;
    LONG	OverFlow;
	LONG	ErrorClock;		// ppm
	LONG	smpDemFreq;		// fW[^̃TvOg
    LONG	TxBuffCount;	// Mobt@̖M
    LONG	dummy[2048];
}COMARRAY;
#pragma pack(pop)
typedef struct {
	DWORD	m_markfreq;
	DWORD	m_spacefreq;
	DWORD	m_siglevel;
	DWORD	m_sqlevel;
	DWORD	m_codeswitch;
	DWORD	m_codeview;
	DWORD	m_notch1;
	DWORD	m_notch2;
	DWORD	m_baud;
    DWORD	m_fig;
}NMMTTY;

#define	swAFC	0x00000004	// b2 AFC
#define	swNET	0x00000008	// b3 NET
#define	swATC	0x00000010	// b4 ATC
#define	swBPF	0x00000020	// b5 BPF
#define	swLMS	0x00000040	// b6 LMS/Notch
#define	swSQ	0x00000080	// b7 SQ
#define	swREV	0x00000100	// b8 Rev
#define	swUOS	0x00000200	// b9 UOS
#define	swNOT	0x00002000	// b13	Notch/LMS
#define	swTWO	0x00004000	// b14

/////////////////////////////////////////////////////////////////////////////
// CSplitter class
class CSplitter
{
private:
	CWnd		*m_pWnd;
	int			m_splitter;
	int			m_top;
	int			m_bottom;
	int			m_edge;
	int			m_minsize;
	HCURSOR		m_hCursor[2];
private:
	BOOL HitTest(CPoint &point);
public:
	CSplitter();
	inline int GetSplitter(void){return m_splitter;};
	BOOL Create(CWnd *pWnd, int splitter, int top, int bottom, int minsize);
	void SetRange(int top, int bottom);
	int OnMouseMove(CPoint &point);
	void OnLButtonDown(CPoint &point);
	void OnLButtonUp(CPoint &point);
};

/////////////////////////////////////////////////////////////////////////////
// CRemMFCDlg _CAO

class CRemMFCDlg : public CDialog
{
private:
	RECT			m_rcClient;
	RECT			m_rcGroup;
	CSplitter		m_Splitter;
private:
	BOOL			m_ptt;
	BOOL			m_Cancel;
	int				m_Wait;
private:
	CString			m_InvokeCommand;
	BOOL			m_bConnected;
private:
	CString			m_Msg[4];
	LONG			m_Shift;
private:
	NMMTTY			m_NMmtty;
	HWND			m_hMMWnd;
	HANDLE			m_hComFile;
	COMARRAY		*m_pCom;

	BOOL			m_bAutoSpectram;
	BOOL			m_bHighXyQuality;
	BOOL			m_bCaptureSpectram;
	BOOL			m_bShowXyScope;

	LONG			m_SpecBase;
	LONG			m_SpecWidth;
	RECT			m_rcSpectram;
	CBitmap			m_bmpSpectram;
	RECT			m_rcLevel;
	CBitmap			m_bmpLevel;
	RECT			m_rcXY;
	CBitmap			m_bmpXY;
private:
	CINTPXY2		*m_pIX;
	CINTPXY2		*m_pIY;
private:
	void OpenMmtty(void);
	void CloseMmtty(BOOL bWait);

private:
	void PutPttStatus(void);
	void DispStatus(void);
	void UpdateDlgButton(void);
	void UpdateControlButton(void);
	void UpdateSpectramWidth(void);
	void UpdateItemSize(void);
	void UpdateSpectramSize(void);
	void OnDrawLevel(void);
	void OnDrawSpectram(COMARRAY *pCom);
	void OnDrawXY(COMARRAY *pCom);
	void DrawLevel(void);
	void DeleteIXY(void);
	void HookKeyMessage(BOOL bHook);

	void PostMmttyMessage(DWORD wParam, DWORD lParam);
	BOOL ProcessMessages(void);
	void DispWaitStatus(void);
	BOOL WaitBusy(void);
	void SendSwitch(DWORD codeswitch);
	BOOL SendString(LPCSTR pStr);
	void SendString(LPCSTR pStr, int size);
	void SendMsgButton(LPCSTR pStr);
public:
	void OnKeyChar(WPARAM wParam, LPARAM lParam);
	void OnFuncKeyChar(WPARAM wParam, LPARAM lParam);
	void OnImageMouse(CImageStatic *pStatic, UINT code, LPRECT prc);
	void OnToggleRClick(CToggleButton *pButton);

// \z
public:
	CRemMFCDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CRemMFCDlg)
	enum { IDD = IDD_REMMFC_DIALOG };
	CDumpStatic	m_DlgTXW;
	CComboBox	m_DlgShift;
	CToggleButton	m_DlgTYPE;
	CToggleButton	m_DlgUOS;
	CToggleButton	m_DlgLMS;
	CToggleButton	m_DlgBPF;
	CToggleButton	m_DlgSQ;
	CToggleButton	m_DlgREV;
	CToggleButton	m_DlgATC;
	CToggleButton	m_DlgNET;
	CToggleButton	m_DlgAFC;
	CToggleButton	m_DlgHAM;
	CImageStatic	m_DlgXY;
	CImageStatic	m_DlgLevel;
	CImageStatic	m_DlgSpectram;
	CToggleButton	m_DlgM4;
	CToggleButton	m_DlgM3;
	CToggleButton	m_DlgM2;
	CToggleButton	m_DlgM1;
	CToggleButton	m_DlgTXOFF;
	CToggleButton	m_DlgTX;
	CButton	m_DlgNGroup;
	CDumpStatic	m_DlgConsole;
	CColorStatic	m_DlgNStatus;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CRemMFCDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CRemMFCDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBtx();
	afx_msg void OnBtxoff();
	afx_msg void OnFileSend();
	afx_msg void OnBm1();
	afx_msg void OnBm2();
	afx_msg void OnBm3();
	afx_msg void OnBm4();
	afx_msg void OnAfc();
	afx_msg void OnNet();
	afx_msg void OnHam();
	afx_msg void OnAtc();
	afx_msg void OnBpf();
	afx_msg void OnLms();
	afx_msg void OnRev();
	afx_msg void OnSq();
	afx_msg void OnType();
	afx_msg void OnUos();
	afx_msg void OnViewSpectramAuto();
	afx_msg void OnViewSpectramWide();
	afx_msg void OnSelchangeShift();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnViewXyscope();
	afx_msg void OnViewHighxyquality();
	afx_msg void OnOptionSetup();
	afx_msg void OnOptionReconnect();
	afx_msg void OnOptionInvoke();
	//}}AFX_MSG
	afx_msg LRESULT OnMmttyMessage(WPARAM wParam, LPARAM lParam);
	afx_msg void OnActivate( UINT nState, CWnd* pWndOther, BOOL bMinimized );
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);
	afx_msg LRESULT OnSocketEvent(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_RemMFCDlg_H__842C61C4_80A2_412E_B5D8_286FEC3FF2DE__INCLUDED_)
